;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DTC interpreted and DO-XXX
;; directly included from "zx-10-startup.f"
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; address interpreter

i-next-push-de-hl:
  push  de
i-next-push-hl:
  push  hl
i-next:
$here zx-do-variable^:!
$here zx-do-2variable^:!
  ld    a, (bc)
  inc   bc
  ld    l, a
  ld    a, (bc)
  inc   bc
  ld    h, a
  jp    hl


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CFA doers

do-colon:
$here zx-do-colon^:!
  ld    hl, () zx-rp
  dec   hl
  ld    (hl), b
  dec   hl
  ld    (hl), c
  ld    zx-rp (), hl
  pop   bc
  jp    # i-next

do-constant:
$here zx-do-constant^:!
  pop   hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
zx-do-constant-finish:
  push  de
  jp    # i-next

do-2constant:
$here zx-do-2constant^:!
  pop   hl
  inc   hl
  inc   hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  push  de
  dec   hl
  dec   hl
  ld    d, (hl)
  dec   hl
  ld    e, (hl)
  \ push  de
  \ jp    # i-next
  jr    # zx-do-constant-finish

\ do-variable:
\ $here zx-do-variable^:!
\   jp    # i-next

\ do-2variable:
\ $here zx-do-2variable^:!
\   jp    # i-next

do-uservar:
$here zx-do-uservar^:!
  pop   hl
  ld    e, (hl)
  ld    d, # 0
  push  ix
  pop   hl
  add   hl, de
  jp    # i-next-push-hl

do-does:
$here zx-do-does^:!
  ld    hl, () zx-rp
  dec   hl
  ld    (hl), b
  dec   hl
  ld    (hl), c
  ld    zx-rp (), hl
  pop   hl
  ld    c, (hl)
  inc   hl
  ld    b, (hl)
  inc   hl
  jp    # i-next-push-hl

do-vocab:
$here zx-do-vocab^:!
  pop   de
  ld    hl, # 4
  add   hl, de
  ld    zx-var-context (), hl
  jr    # i-next
