;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; memory access primitives
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


<zx-definitions>

code: 2@  ( addr -- d )
  pop   hl
  inc   hl
  inc   hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  push  de
  dec   hl
  dec   hl
  ld    d, (hl)
  dec   hl
  ld    e, (hl)
  push  de
;code

code: 2!  ( d addr )
  pop   hl
  pop   de
  ld    (hl), e
  inc   hl
  ld    (hl), d
  inc   hl
  pop   de
  ld    (hl), e
  inc   hl
  ld    (hl), d
;code


code: COUNT  ( addr -- addr+1 b[addr] )
  pop   hl
  ld    a, (hl)
zx-word-count-finish:
  inc   hl
  push  hl
  ld    l, a
  ld    h, # 0
;code-push-hl

code: C@++  ( addr -- addr+1 b[addr] )
  jr    # zx-word-count
;code-no-next

code: IDCOUNT  ( addr -- addr+1 b[addr]&31 )
  pop   hl
  ld    a, (hl)
  and   # $1F
  jr    # zx-word-count-finish
;code-no-next


code: +!  ( value addr )
  pop   hl
  pop   de
zx-word-add-store-finish:
  ld    a, (hl)
  add   a, e
  ld    (hl), a
  inc   hl
  ld    a, (hl)
  adc   a, d
  ld    (hl), a
;code

code: SWAP+!  ( addr value )
  pop   de
  pop   hl
  jr    # zx-word-add-store-finish
;code-no-next

: 1+!  ( addr )  1 SWAP+! ;


code: TOGGLE  ( addr byte )
  pop   de
  pop   hl
  ld    a, (hl)
  xor   e
  ld    (hl), a
;code


code: @  ( addr -- value )
  pop   hl
  ld    e, (hl)
  inc   hl
  ld    d, (hl)
  push  de
;code

code: C@  ( addr -- byte )
  pop   hl
  ld    l, (hl)
  ld    h, # 0
;code-push-hl

code: !  ( value addr )
  pop   hl
  pop   de
zx-word-store-finish:
  ld    (hl), e
  inc   hl
  ld    (hl), d
;code

code: SWAP!  ( addr value )
  pop   de
  pop   hl
  jr    # zx-word-store-finish
;code-no-next

code: C!  ( byte addr )
  pop   hl
  pop   de
  ld    (hl), e
;code

: ON  ( addr )  1 SWAP! ;
: OFF ( addr )  0 SWAP! ;


<zx-done>
