;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; more high-level words
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


<zx-definitions>

code: (TAPE)  ( opcode )
  pop   hl
  push  bc
  push  ix
  ld    a, l
  ld    hl, # zx-ramdisc^
  ld    ix, # tape-load-header
  ld    $5C74 (), a
  call  # $075A
  pop   ix
  pop   bc
  next
flush!

tape-load-header:
  3 db,   ;; filetype: code file
  ;; filename: "DISC      "
  68 db, 73 db, 83 db, 67 db, 32 db,
  32 db, 32 db, 32 db, 32 db, 34 db,
tape-load-header-length:
  zx-#ramdisc 1- dw, ;; FIXME: it should be $2C00
tape-load-header-address:
  zx-ramdisc^ dw,
tape-load-header-not-used:
  $2020 dw,

tape-save-header:
  3 db,   ;; filetype: code file
  ;; filename: "DISC      "
  68 db, 73 db, 83 db, 67 db, 32 db,
  32 db, 32 db, 32 db, 32 db, 34 db,
tape-save-header-length:
  zx-#ramdisc 1- dw, ;; FIXME: it should be $2C00
tape-save-header-address:
  zx-ramdisc^ dw,
tape-save-header-not-used:
  $2020 dw,
;code-no-next


: LOADT  1 (TAPE) ;
: SAVET  FLUSH 0 (TAPE) ;
: VERIFY 2 (TAPE) ;

: SIZE  ( -- n )  HERE ( 0 +ORIGIN) [ zx-base-addr ] {#,} - ;
: FREE  ( -- n )  SP@ HERE - ;


: LIST  ( n )
  DECIMAL CR DUP SCR ! ." SCR # " .
  16 0 DO
    CR I 3 .R SPACE I SCR @ .LINE ?TERMINAL IF LEAVE ENDIF
  LOOP CR ;

: TEXT  ( c )  HERE C/L 1+ BLANKS WORD HERE PAD C/L 1+ CMOVE ;

: LINE  ( n -- addr )  DUP -16 AND 23 ?ERROR SCR @ (LINE) DROP ;


OPT-MORE-BLOCK-WORDS? [IF]
: INDEX  ( from to )
  CLS 1+ SWAP DO
    CR I 3 .R SPACE 0 I .LINE ?TERMINAL IF LEAVE ENDIF
  LOOP ;

: TRIAD  ( scr )
  CLS 3 / 3 * 3 OVER + SWAP DO
    CR I LIST ?TERMINAL IF LEAVE ENDIF
  LOOP ;

: WHERE  ( n1 n2 )
  DUP B/SCR / DUP SCR ! ." SCR # " DECIMAL .
  SWAP C/L /MOD C/L * ROT BLOCK + CR
  C/L TYPE CR
  HERE C@ - SPACES 94 EMIT
  [COMPILE] EDITOR
  QUIT ;
[ENDIF]

<zx-done>
