;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; high-level low-level words ;-)
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


OPT-REL-BRANCH? [IF]
;; compile branch offset from HERE
tcom:zx: BACK  ( addr )  HERE - , ;
;; patch forward branch at addr to HERE
tcom:zx: FWRD  ( addr )  HERE OVER - SWAP! ;
[ELSE]
;; compile branch offset from HERE
tcom:zx: BACK  ( addr )  , ;
;; patch forward branch at addr to HERE
tcom:zx: FWRD  ( addr )  HERE SWAP! ;
[ENDIF]

<zx-definitions>

;; compile dummy branch offset, return offset address
: BMARK  ( -- addr )  HERE 0 , ;

: !CSP  SP@ CSP ! ;

*: BEGIN  ?COMP HERE 1 ;
*: ENDIF  ?COMP 2 ?PAIRS FWRD ;
*: THEN   [COMPILE] ENDIF ;

*: DO    COMPILE (DO) HERE 3 ;
*: LOOP  3 ?PAIRS COMPILE (LOOP) BACK ;
*: +LOOP 3 ?PAIRS COMPILE (+LOOP) BACK ;

*: UNTIL   1 ?PAIRS COMPILE 0BRANCH BACK ;
*: 0UNTIL  1 ?PAIRS COMPILE TBRANCH BACK ;
\ *: END    [COMPILE] UNTIL ; -- commented by k8

*: AGAIN  1 ?PAIRS COMPILE BRANCH BACK ;
*: REPEAT >R >R [COMPILE] AGAIN R> R> 2- [COMPILE] ENDIF ;

*: IF     COMPILE 0BRANCH BMARK 2 ;
*: 0IF    COMPILE TBRANCH BMARK 2 ;
*: ELSE   2 ?PAIRS COMPILE BRANCH BMARK SWAP 2 [COMPILE] ENDIF 2 ;

*: WHILE   [COMPILE] IF 2+ ;
*: 0WHILE  [COMPILE] 0IF 2+ ;

*: CASE  ?COMP CSP @ !CSP 4 ;
*: OF    4 ?PAIRS COMPILE OVER COMPILE = COMPILE 0BRANCH BMARK COMPILE DROP 5 ;
*: ENDOF 5 ?PAIRS COMPILE BRANCH BMARK SWAP 2 [COMPILE] ENDIF 4 ;
*: ENDCASE
  4 ?PAIRS COMPILE DROP
  BEGIN SP@ CSP @ = 0= WHILE 2 [COMPILE] ENDIF REPEAT
  CSP ! ;

<zx-done>
