;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; word creation
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


<zx-definitions>

: CREATE  \ name
  -FIND IF DROP NFA ID. 4 MESSAGE SPACE ENDIF
  HERE DUP C@ WIDTH @ MIN 1+ ALLOT DUP 160 TOGGLE
  HERE 1- 128 TOGGLE
  LATEST , CURRENT @ !
  ;; create CFA (for code word)
  [ OPT-DTC? ] [IF] ( compile JP) $C3 C, [ENDIF]
  HERE 2+ , ;

;; set latest CFA to the given code address
<zx-hidden>

: !CODE  ( code-addr )
  LATEST PFA CFA  ( code-addr cfa )
  [ OPT-DTC? ] [IF]
    $CD OVER C! ;; CALL
    1+
  [ENDIF] ! ;
<zx-normal>

: VOCABULARY
  CREATE
  \ IMMEDIATE   ;; k8: for some reason vocabs are immediate; this was missing in the original
  ( reserved) 0 ,
  ( dummy header) $A081 ,
  ( latest) CURRENT @ CFA ,
  ( voclink) HERE VOC-LINK @ , VOC-LINK !
  [ZX-DO-VOCAB] !CODE ;

: DEFINITIONS
  CONTEXT @ CURRENT ! ;

*: [  STATE OFF ;
: ]  192 STATE ! ;

: CONSTANT  ( value )  \ name
  CREATE SMUDGE , [ZX-DO-CONSTANT] !CODE ;

: VARIABLE  ( value )  \ name
  CONSTANT [ZX-DO-VARIABLE] !CODE ;

: USER  ( value )  \ name
  CONSTANT [ZX-DO-USERVAR] !CODE ;

: 2CONSTANT  ( d )  \ name
  CREATE SMUDGE HERE 2! 4 ALLOT [ZX-DO-2CONSTANT] !CODE ;

: 2VARIABLE  ( d )  \ name
  2CONSTANT [ZX-DO-2VARIABLE] !CODE ;

: <BUILDS  0 CONSTANT ;
: DOES>  R> LATEST PFA ! [ZX-DO-DOES] !CODE ;

*: :  ?EXEC !CSP CURRENT @ CONTEXT ! CREATE [COMPILE] ] [ZX-DO-COLON] !CODE ;
*: ;  ?CSP COMPILE ;S SMUDGE [COMPILE] [ ;

*: (  \ )
  41 WORD ;


<zx-done>
