;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; various other words
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


<zx-definitions>

code: CLS
  push  bc
  ld    a, # 2
  call  # $1601
  call  # $0D6B
  ld    a, # 2
  call  # $1601
  pop   bc
;code

code: INP  ( port -- value )
  pop   hl
  push  bc
  ld    bc, hl
  in    a, (c)
  pop   bc
zx-next-push-a:
  ld    h, # 0
  ld    l, a
;code-push-hl

code: OUTP  ( value port )
  pop   hl
  pop   de
  push  bc
  ld    bc, hl
  ld    a, e
  out   (c), a
  pop   bc
;code

;; Returns the ascii value of the character at line n1, column n2 as long as
;; that character is not a user-defined character.
code: SCREEN  ( y x -- char )
  pop   hl
  pop   de
  push  bc
  push  ix
  ld    c, e
  ld    b, l
  call  # $2538
  call  # $2BF1
  ld    a, (de)
zx-next-pop-ix-bx-push-a:
  pop   ix
  pop   bc
  jr    # zx-next-push-a
;code-no-next

code: BORDER  ( color )
  pop   hl
  push  bc
  ld    a, l
  call  # $2297
  pop   bc
;code

code: BLEEP  ( duration pitch )
  pop   hl
  pop   de
  push  bc
  push  ix
  \ call  # $03B5
  \ pop   ix
  \ pop   bc
  jp    # zx-word-kbeep-do-beep
;code-no-next

code: ATTR  ( y x -- attr )
  pop   hl
  pop   de
  push  bc
  push  ix
  ld    c, e
  ld    b, l
  call  # $2583
  call  # $1E94
  jr    # zx-next-pop-ix-bx-push-a
;code-no-next

code: POINT  ( x y -- flag )
  pop   hl
  pop   de
  push  bc
  push  ix
  ld    c, e
  ld    b, l
  ld    a, l
  cp    # 176
  jr    c, # .ok
  ld    a, # 175
  ld    b, a
.ok:
  call  # $22CE
  call  # $1E94
  jr    # zx-next-pop-ix-bx-push-a
;code-no-next

code: PLOT  ( x y )
  pop   hl
  pop   de
  push  bc
  push  ix
  ld    c, e
  ld    b, l
  ld    a, h
  or    d
  jr    nz, # .skip
  ld    a, l
  cp    # 176
  jr    nc, # .skip
  call  # $22DF
.skip:
  pop   ix
  pop   bc
;code


: AT  ( y x )
  ABS DUP 31 > IF 2DROP
  ELSE SWAP ABS DUP 21 > IF 2DROP
  ELSE 22 EMIT EMIT EMIT ENDIF ENDIF ;

: PAPER  ( n )
  ABS DUP 9 > IF DROP
  ELSE
    DUP 9 = IF 23697 C@ 128 OR 23697 C! DROP
    ELSE
      DUP 8 = IF 23694 C@ 56 OR 23694 C! DROP
      ELSE 8 * 23693 C@ 199 AND OR 23693 C! 23697 C@ 127 AND 23697 ! 23694 C@ 199 AND 23694 !
  ENDIF ENDIF ENDIF ;

: INK  ( n )
  ABS DUP 9 > IF DROP
  ELSE
    DUP 9 = IF 23697 C@ 32 OR 23697 C! DROP
    ELSE
      DUP 8 = IF 23694 C@ 7 OR 23694 C! DROP
      ELSE 23693 C@ 248 AND OR 23693 C! 23697 C@ 223 AND 23697 ! 23694 C@ 248 AND 23694 !
  ENDIF ENDIF ENDIF ;

: FLASH   ( flag )  23693 C@ SWAP IF 128 OR ELSE 127 AND ENDIF 23693 ! ;
: BRIGHT  ( flag )  23693 C@ IF 64 OR ELSE 191 AND ENDIF 23693 ! ;
: GOVER   ( flag )  23697 C@ IF 2 OR ELSE 253 AND ENDIF 23697 ! ;
: INVERSE ( flag )  23697 C@ IF 8 OR ELSE 247 AND ENDIF 23697 ! ;


0 zx-2variable INCX
0 zx-2variable INCY
0 zx-2variable X1
0 zx-2variable Y1

: DRAW  ( ex ey )
  23678 C@ DUP 0 SWAP Y1 2! - DUP ABS ROT 23677 C@ DUP 0 SWAP X1 2! - DUP ABS ROT MAX >R
  DUP 0< IF ABS 0 SWAP R M/MOD DMINUS ELSE 0 SWAP R M/MOD ENDIF
  INCX 2! DROP DUP 0< IF ABS 0 SWAP R M/MOD DMINUS ELSE 0 SWAP R M/MOD ENDIF
  INCY 2! DROP R> 1+ 0 DO
    X1 @ Y1 @ PLOT
    X1 2@ INCX 2@ D+ X1 2!
    Y1 2@ INCY 2@ D+ Y1 2!
  LOOP ;

;; bugfixed by k8
: INIT-DISC  [ zx-ramdisc^ ] {#,} [ zx-#ramdisc ] {#,} BLANKS ;

: UDG  ( -- udgstart^ )  23675 @ ;


0 [IF]
<zx-hidden>
code: (BP)
  zxemut-bp
;code
[ENDIF]


<zx-done>
