;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TCOM conditions and loops
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

extend-module SHADOW-HELPERS
<private-words>

0 quan (CSP)

: CSP@  ( -- csp )  (csp) ;
: CSP!  ( value  )  (csp):! ;
: !CSP  depth csp! ;

: ?PAIRS  ( a b )  system:?pairs ;

<published-words>
: BEGIN  zx-?comp zx-<j-mark 1 ;
: ENDIF  zx-?comp 2 ?pairs zx-resolve-j> ;

: DO    forth-shadows:(DO) zx-<j-mark 3 ;
: LOOP  3 ?pairs forth-shadows:(LOOP) zx-<j-resolve ;
: +LOOP 3 ?pairs forth-shadows:(+LOOP) zx-<j-resolve ;

: UNTIL   1 ?pairs forth-shadows:0BRANCH zx-<j-resolve ;
: 0UNTIL  1 ?pairs forth-shadows:TBRANCH zx-<j-resolve ;

: AGAIN  1 ?pairs forth-shadows:BRANCH zx-<j-resolve ;
: REPEAT 2>r [\\] AGAIN 2r> 2- [\\] ENDIF ;

: IF     forth-shadows:0BRANCH zx-mark-j> 2 ;
: 0IF    forth-shadows:TBRANCH zx-mark-j> 2 ;
: ELSE 2 ?pairs forth-shadows:BRANCH zx-mark-j> swap zx-resolve-j> 2 ;

: WHILE   forth-shadows:0BRANCH zx-mark-j> 4 ;
: 0WHILE  forth-shadows:TBRANCH zx-mark-j> 4 ;

: CASE  zx-?comp csp@ !csp 4 ;
: OF    4 ?pairs forth-shadows:OVER forth-shadows:= forth-shadows:0BRANCH zx-mark-j> forth-shadows:DROP 5 ;
: ENDOF 5 ?pairs forth-shadows:BRANCH zx-mark-j> swap 2 [\\] ENDIF 4 ;
: ENDCASE
  4 ?pairs forth-shadows:DROP
  << depth csp@ = not?^| 2 [\\] ENDIF |? else| >>
  csp! ;

end-module \ SHADOW-HELPERS

end-module \ TCOM
