;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; simple ZX decompiler
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

0 quan forth-name-cfa (private)

OPT-DTC? [IF]
|: forth-name-checker  ( zx-cfa shadow-cfa -- zx-cfa res )
  \ dup zx-forth? not?exit< drop 0 >?
  2dup dart:cfa>pfa ss>zxcfa:@ = ?exit< forth-name-cfa:! 1 >?
  2dup dart:cfa>pfa ss>zxcfa:@ 3 - = ?exit< forth-name-cfa:! 1 >?
  drop 0 ;
[ELSE]
|: forth-name-checker  ( zx-cfa shadow-cfa -- zx-cfa res )
  \ dup zx-forth? not?exit< drop 0 >?
  2dup dart:cfa>pfa ss>zxcfa:@ = not?exit< drop 0 >?
\ endcr ." |" dup dart:cfa>nfa debug:.id ." | " dup dart:cfa>pfa c@ . over 0.r cr
  forth-name-cfa:! 1 ;
[ENDIF]

: zx-forth-name  ( zx-addr -- addr count )
  forth-name-cfa:!0
  vocid: forth-shadows ['] forth-name-checker vocid-foreach nip
  ?< forth-name-cfa dart:cfa>nfa idcount || " <???>" >? ;


module decompiler
<disable-hash>

0 quan zx-addr
0 quan zx-addr-start
0 quan zx-addr-end

: cfetch  ( -- ubyte )  zx-addr zx-c@ zx-addr:1+! ;
: wfetch  ( -- word )   cfetch cfetch 256 * or ;
: brfetch ( -- bdest )  zx-addr zx-brdest@ 2 zx-addr:+! ;

: .lit  ( n )
  dup .
  dup ." [$" .hex4 ." ]"
  dup $8000 < ?exit< drop >?
  ."  (" $FF_FF_00_00 or 0.r ." )" ;

: op-wlit  bl emit wfetch .lit ;
: op-clit  bl emit cfetch .lit ;
: op-blit  bl emit cfetch $FF00 or .lit ;

: op-s8lit
  ."  \'" cfetch
  << dup ?^| 1-
      cfetch
      dup 34 = ?< drop ." \\'"
      || dup 32 127 within ?< emit
      || ." \\x" .hex2 >? >? |?
  else| drop >> ." \'" ;

: op-branch  brfetch ."  $" .hex4 ;


0 quan highest-jump

: end?  ( zx-cfa )
  << zx-['] ;S of?v| true |?
     zx-['] EXIT of?v| true |?
  else| drop false >> ;

: branch?  ( zx-cfa )
  << zx-['] BRANCH of?v| true |?
     zx-['] 0BRANCH of?v| true |?
     zx-['] TBRANCH of?v| true |?
     zx-['] (LOOP) of?v| true |?
     zx-['] (+LOOP) of?v| true |?
  else| drop false >> ;

: lit?  ( zx-cfa )  zx-['] LIT = ;
: slit?  ( zx-cfa )  zx-['] (.") = ;

OPT-CLIT? [IF]
: clit?  ( zx-cfa )  zx-['] CLIT = ;
: blit?  ( zx-cfa )  zx-['] BLIT = ;
[ENDIF]


: trace-jumps
  zx-addr-start zx-addr:!
  zx-addr highest-jump:!
  << wfetch
     dup end? ?of?^| zx-addr highest-jump u> ?exit |?
     dup zx-['] branch = ?< zx-addr zx-brdest@ zx-addr u< ?< zx-addr highest-jump u> ?exit< drop >? >? >?
     dup branch? ?of?^| brfetch highest-jump max highest-jump:! |?
     dup lit? ?of?^| wfetch drop |?
     [ OPT-CLIT? ] [IF]
     dup clit? ?of?^| cfetch drop |?
     dup blit? ?of?^| cfetch drop |?
     [ENDIF]
     dup slit? ?of?^| cfetch zx-addr:+! |?
  ^| drop | >> ;


: .one
  endcr zx-addr .hex4 ." : "
  wfetch dup zx-forth-name type
  << dup lit? ?of?v| op-wlit |?
     [ OPT-CLIT? ] [IF]
     dup clit? ?of?v| op-clit |?
     dup blit? ?of?v| op-blit |?
     [ENDIF]
     dup branch? ?of?v| op-branch |?
     dup slit? ?of?v| op-s8lit |?
  else| drop >> cr ;

: (see)  ( cfa )
  [ OPT-DTC? ] [IF]
    dup 1+ zx-w@ zx-do-colon^ = not?error" not a Forth word"
    3 +  ;; move to PFA
  [ELSE]
    dup zx-w@ zx-do-colon^ = not?error" not a Forth word"
    2+  ;; move to PFA
  [ENDIF]
  zx-addr-start:!
  trace-jumps zx-addr zx-addr-end:!
  endcr ." === START:$" zx-addr-start .hex4 ."  END:$" zx-addr-end .hex4 ."  ===\n"
  zx-addr-start zx-addr:!
  << zx-addr zx-addr-end u< ?^| .one |? else| >> ;

end-module

: zx-see  \ name
  (-zx-find) decompiler:(see) ;

end-module
