;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; simple ZX Spectrum assembler
;; coded by Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; assembler mode words
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


module zx-code-def
<disable-hash>
using z80-labman

: [@@]  ( -- value )
  parse-name z80-labman:@get ;

: @def: ( value )  \ label-name
  parse-name z80-labman:@set ;

: @def-global: ( value )  \ label-name
  parse-name z80-labman:define
  z80-labman:reset-locals ;

: <end-asm>
  system:?exec
  z80asm:instr:end-code
  pop-ctx pop-ctx pop-ctx ;

: org  ( value )
  dup 0 65535 bounds not?error" invalid ORG value"
  zxa:org! ;

: ent  ( value )
  dup 0 65535 bounds not?error" invalid ENT value"
  zxa:ent! ;

: clr  ( value )
  dup 24000 65535 bounds not?error" invalid CLR value"
  1- zxa:clr! ;


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ZXEmuT macros

extend-module z80asm:instr

: zxemut-bp
  z80asm:flush
  $ED db, $FE db, $18 db,
  1 db, 2 db,
;

: zxemut-pause
  z80asm:flush
  $ED db, $FE db, $18 db,
  2 db, $10 db, 0 db,
;

: zxemut-max-speed
  z80asm:flush
  $ED db, $FE db, $18 db,
  2 db, $10 db, 1 db,
;

: zxemut-normal-speed
  z80asm:flush
  $ED db, $FE db, $18 db,
  2 db, $10 db, 2 db,
;

end-module \ instr


end-module \ zx-code-def


*: <asm>
  system:?exec
  push-ctx voc-ctx: z80-labman:unk-labels
  push-ctx voc-ctx: z80-labman:zx-labels
  push-ctx voc-ctx: zx-code-def
  z80-code ;
